---
schema_version: "1"
id: b55d859bce850fac2b2cc5cf3523a7c399bff0a3d3f4e33950d58ef247daa5a6
title: TMF621 v4 Trouble Ticket Management
collection: developer
version: current
locale: en-us
portal_url: https://docs.salesforce.com/developer/current/en-us/industries-integrations/comms/references/generated-api-specs/tmf621v4.md
canonical_url: https://developer.salesforce.com/docs/industries/communications/references/tmf621v4
source_site: developer.salesforce.com
content_type: documentation
content_hash: 9255ff4299ad6fab9f9f7743e5e9acbb7db2eae2de37a52a57ba39e1730e41dc
products:
  - Communications Cloud TM Forum API
  - Industries Integrations
---
TMF621 v4 Trouble Ticket Management

# TMF621 v4 Trouble Ticket Management

The TMF Trouble Ticket API (TMF 621) provides a standardised client interface to Trouble Ticket Management Systems for creating, tracking and managing trouble tickets as a result of an issue or problem identified by a customer or another system.The data exchange is compliant with the TM Forum's Open API specification.

**Version:** v1

Protocols: https.

## Operations

### GET List All Trouble Ticket

`GET /troubleTicket`

This operation list or find TroubleTicket entities.

#### Parameters

*   `fields` (query, string) Specifies the comma-separated properties to provide in the response. Accepted fields are \[name, description, priority, status, lastUpdate, ticketType, creationDate, resolutionDate, severity\]
*   `severity` (query, string) Specifies the filter for provided severity. The supported values are org specific and are dependent on the configuration within the org.
*   `ticketType` (query, string) Specifies the filter for provided Ticket Type.
*   `priority` (query, string) Specifies the filter for provided Priority. The supported values are org specific and are dependent on the configuration within the org.
*   `status` (query, string) Specifies the filter for provided Status. The supported values are org specific and are dependent on the configuration within the org.
*   `name` (query, string) Filter based on Name.
*   `description` (query, string) Filter based on description.
*   `offset` (query, integer) Specifies the requested index for the start of the resources to be included in the response.
*   `limit` (query, integer) Specifies the requested number of the resources to be included in the response.
*   `Authorization` (header, string, required) Specifies the bearer token to use for the authentication of request.
*   `Namespace` (header, string) Specifies the namespace to use with the URL path.
*   `Domain-Name` (header, string, required) Specifies the domain name to use with the URL path received from the userinfo API.

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `array of object`.
    
    Array of `object`.
    
    *   `id` (_string_, required) Specifies the unique identifier of the TroubleTicket.
    *   `href` (_string_, required) Specifies the unique reference of the TroubleTicket.
    
    _Example_
    
    ```
    [
        {
            "channel": {
                "@type": "Channel",
                "name": "Phone"
            },
            "relatedParty": [
                {
                    "@referredType": "Account",
                    "name": "Burlington Textiles Corp of America",
                    "id": "001RO000003zz9SYAQ"
                },
                {
                    "@referredType": "Contact",
                    "name": "Jack Rogers",
                    "id": "003RO00000366d5YAA"
                }
            ],
            "statusChangeDate": "2022-09-21T05:24:40.000Z",
            "name": "sample name from subject",
            "id": "00001020",
            "lastUpdate": "2022-09-21T05:24:40.000+0000",
            "resolutionDate": "2021-08-03T18:59:51.000+0000",
            "ticketType": "Electrical",
            "status": "Closed",
            "priority": "Medium",
            "creationDate": "2022-09-21T05:24:40.000+0000",
            "href": "/services/apexrest/vlocity_cmt/tmforum/troubleticket/v1/troubleticket/00001020"
        },
        {
            "channel": {
                "@type": "Channel",
                "name": "Phone"
            },
            "relatedParty": [
                {
                    "@referredType": "Account",
                    "name": "United Oil & Gas Corp.",
                    "id": "001RO000003zz9WYAQ"
                },
                {
                    "@referredType": "Contact",
                    "name": "Stella Pavlova",
                    "id": "003RO00000366dAYAQ"
                }
            ],
            "statusChangeDate": "2022-09-21T05:24:40.000Z",
            "name": "sample name from subject",
            "id": "00001021",
            "lastUpdate": "2022-09-21T05:24:40.000+0000",
            "resolutionDate": "2021-08-03T18:59:51.000+0000",
            "ticketType": "Structural",
            "status": "Closed",
            "priority": "High",
            "creationDate": "2022-09-21T05:24:40.000+0000",
            "href": "/services/apexrest/vlocity_cmt/tmforum/troubleticket/v1/troubleticket/00001021"
        },
        {
            "attachment": [
                {
                    "name": "SampleFtest",
                    "id": "069RO0000004R1EYAU"
                },
                {
                    "name": "anotherAttachemt",
                    "id": "069RO0000004WqwYAE"
                }
            ],
            "channel": {
                "@type": "Channel",
                "name": "Web"
            },
            "note": [
                {
                    "id": "00aRO000000dbgtYAA",
                    "date": "2023-03-01T14:53:16.000+0000",
                    "text": "This is a sample comment/Note for testing",
                    "author": "Zainul Abidin Mulla",
                    "@type": "CaseComment"
                },
                {
                    "id": "00aRO000000dbh8YAA",
                    "date": "2023-03-02T02:05:19.000+0000",
                    "text": "Case comment 2",
                    "author": "Zainul Abidin Mulla",
                    "@type": "CaseComment"
                },
                {
                    "id": "00aRO000000dbhDYAQ",
                    "date": "2023-03-02T03:17:56.000+0000",
                    "text": "putting on hold",
                    "author": "Zainul Abidin Mulla",
                    "@type": "CaseComment"
                }
            ],
            "relatedEntity": [
                {
                    "@referredType": "Asset",
                    "name": "Galaxy M01",
                    "id": "02iRO00000077Z0YAI"
                },
                {
                    "@referredType": "Product",
                    "name": "4G Router CFS",
                    "id": "01tRO000000XnTNYA0"
                }
            ],
            "relatedParty": [
                {
                    "@referredType": "Account",
                    "name": "United Oil & Gas Corp.",
                    "id": "001RO000003zz9WYAQ"
                },
                {
                    "@referredType": "Contact",
                    "name": "Stella Pavlova",
                    "id": "003RO00000366dAYAQ"
                }
            ],
            "statusChange": [
                {
                    "changeDate": "2023-03-08T18:19:07.000+0000",
                    "status": "Escalated"
                },
                {
                    "changeDate": "2023-03-02T03:17:56.000+0000",
                    "status": "On Hold"
                },
                {
                    "changeDate": "2023-03-02T03:13:15.000+0000",
                    "status": "Pending"
                }
            ],
            "troubleTicketRelationship": [
                {
                    "relationshipType": "Parent",
                    "id": "500RO000002K2YXYA0"
                }
            ],
            "statusChangeDate": "2023-03-08T18:19:07.000Z",
            "name": "sample name from subject",
            "id": "00001022",
            "severity": "Critical",
            "lastUpdate": "2023-03-11T04:05:50.000+0000",
            "resolutionDate": "2021-08-03T18:59:51.000+0000",
            "ticketType": "Electronic",
            "status": "Escalated",
            "priority": "Medium",
            "creationDate": "2022-09-21T05:24:40.000+0000",
            "description": "This is sample description for testing",
            "href": "/services/apexrest/vlocity_cmt/tmforum/troubleticket/v1/troubleticket/00001022"
        }
    ]
    ```
    
*   **400** There was an issue with your request.
    
    Media type: `application/json`. Schema: `Error`.
    
    _Example_
    
    ```
    code: "400"
    reason: Invalid picklist value for :Priority
    ```
    
*   **404** Resource not found.
    
    Media type: `application/json`. Schema: `Error`.
    
    _Example_
    
    ```
    code: NOT_FOUND
    reason: There are no matching resource.
    message: There are no data in system or not data for specified filters.
    ```
    
*   **500** Internal server Error
    
    Media type: `application/json`. Schema: `Error`.
    
    _Example_
    
    ```
    code: "500"
    reason: Internal server Error
    ```
    

### POST Creates a TroubleTicket

`POST /troubleTicket`

Creates a TroubleTicket entity.

#### Parameters

*   `Authorization` (header, string, required) Specifies the bearer token to use for the authentication of request.
*   `Namespace` (header, string) Specifies the namespace to use with the URL path.
*   `Domain-Name` (header, string, required) Specifies the domain name to use with the URL path received from the userinfo API.

#### Request body

Media type: `application/json`. Schema: `createTroubleTicket`.

Specifies the TroubleTicket to be created.

_Example_

```
{
    "status": "NEW",
    "description": "new description testing",
    "ticketType": "Manage Account",
    "priority": "High",
    "severity" : "Minor",
    "name" : "new case",
    "note": [
        {
            "text": "Working on TMF12223",
            "author": "NA"
        }
    ],
    "relatedParty": [
        {
            "id": "0018V00002YjSaRQAV",
            "name": "Customer Account"
        },
        {
            "id": "0038V00002Xapl3QAB",
            "name": "Andy Young"
        }
    ],
    "channel": {
        "name": "Phone"
    },
    "troubleTicketRelationship": [
        {
            "id": "00001018",
            "relationshipType": "Parent"
        }
    ],
    "relatedEntity": [
        {
            "id": "01t8V000009AKjcQAG",
            "name": "aProductOffering",
            "@referredType" : "Product"
            
        }
    ],
    "attachment": [
        {
            "description": "Scanned disputed bill",
            "mimeType": "image/png",
            "name": "March Bill",
            "url": "https://mycsp.com:7070/docloader?docnum=3534555",
            "content": "123"
        }
    ]
}
```

#### Responses

*   **201** Created the TroubleTicket.
    
    Media type: `application/json`. Schema: `object`.
    
    *   `id` (_string_, required) Specifies the unique identifier of the TroubleTicket.
    *   `href` (_string_, required) Specifies the unique reference of the TroubleTicket.
    
    _Example_
    
    ```
    {
            "attachment": [
                {
                    "id": "00P8V00001rScmgUAC",
                    "name": "March Bill"
                }
            ],
            "channel": {
                "name": "Phone",
                "@type": "Channel"
            },
            "note": [
                {
                    "text": "Working on TMF12223",
                    "id": "00a8V00000MUcRVQA1",
                    "date": "2023-03-29T05:30:23.000+0000",
                    "author": "devorg devorg",
                    "@type": "CaseComment"
                }
            ],
            "relatedEntity": [
                {
                    "name": "aProductOffering",
                    "id": "01t8V000009AKjcQAG",
                    "@referredType": "Product"
                }
            ],
            "relatedParty": [
                {
                    "name": "Customer Account",
                    "id": "0018V00002YjSaRQAV",
                    "@referredType": "Account"
                },
                {
                    "name": "Andy Young",
                    "id": "0038V00002Xapl3QAB",
                    "@referredType": "Contact"
                }
            ],
            "troubleTicketRelationship": [
                {
                    "relationshipType": "Parent",
                    "id": "00001018"
                }
            ],
            "href": "/services/apexrest/vlocity_cmt/tmforum/troubleticket/v1/troubleticket/00002211",
            "ticketType": "Manage Account",
            "status": "New",
            "severity": "Minor",
            "priority": "High",
            "name": "new case",
            "lastUpdate": "2023-03-29T05:30:22.000+0000",
            "description": "new description testing",
            "creationDate": "2023-03-29T05:30:22.000+0000",
            "id": "00002211"
        }
    ```
    
*   **400** There was an issue with your request.
    
    Media type: `application/json`. Schema: `Error`.
    
    _Example_
    
    ```
    code: "400"
    reason: Invalid picklist value for :Priority
    ```
    
*   **404** Resource not found.
    
    Media type: `application/json`. Schema: `Error`.
    
    _Example_
    
    ```
    code: NOT_FOUND
    reason: There are no matching resource.
    message: There are no data in system or not data for specified filters.
    ```
    
*   **500** Internal server Error
    
    Media type: `application/json`. Schema: `Error`.
    
    _Example_
    
    ```
    code: "500"
    reason: Internal server Error
    ```
    

### GET Retrieves a TroubleTicket by ID

`GET /troubleTicket/{id}`

Retrieves a TroubleTicket entity. Attribute selection is enabled for first-level attributes.

#### Parameters

*   `id` (path, string, required)
*   `fields` (query, string) Specifies the comma-separated properties to provide in the response. Accepted fields are \[name, description, priority, status, lastUpdate, ticketType, creationDate, resolutionDate, severity\]
*   `Authorization` (header, string, required) Specifies the bearer token to use for the authentication of request.
*   `Namespace` (header, string) Specifies the namespace to use with the URL path.
*   `Domain-Name` (header, string, required) Specifies the domain name to use with the URL path received from the userinfo API.

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `object`.
    
    *   `id` (_string_, required) Specifies the unique identifier of the TroubleTicket.
    *   `href` (_string_, required) Specifies the unique reference of the TroubleTicket.
    
    _Example_
    
    ```
    {
        "attachment": [
            {
                "name": "SampleFtest",
                "id": "069RO0000004R1EYAU"
            },
            {
                "name": "anotherAttachemt",
                "id": "069RO0000004WqwYAE"
            }
        ],
        "channel": {
            "@type": "Channel",
            "name": "Web"
        },
        "note": [
            {
                "date": "2023-03-01T14:53:16.000+0000",
                "text": "This is a sample comment/Note for testing",
                "id": "00aRO000000dbgtYAA",
                "author": "Zainul Abidin Mulla",
                "@type": "CaseComment"
            },
            {
                "date": "2023-03-02T02:05:19.000+0000",
                "text": "Case comment 2",
                "id": "00aRO000000dbh8YAA",
                "author": "Zainul Abidin Mulla",
                "@type": "CaseComment"
            },
            {
                "date": "2023-03-02T03:17:56.000+0000",
                "text": "putting on hold",
                "id": "00aRO000000dbhDYAQ",
                "author": "Zainul Abidin Mulla",
                "@type": "CaseComment"
            }
        ],
        "relatedEntity": [
            {
                "name": "Galaxy M01",
                "id": "02iRO00000077Z0YAI",
                "@referredType": "Asset"
            },
            {
                "name": "4G Router CFS",
                "id": "01tRO000000XnTNYA0",
                "@referredType": "Product"
            }
        ],
        "relatedParty": [
            {
                "@referredType": "Account",
                "name": "United Oil & Gas Corp.",
                "id": "001RO000003zz9WYAQ"
            },
            {
                "@referredType": "Contact",
                "name": "Stella Pavlova",
                "id": "003RO00000366dAYAQ"
            }
        ],
        "statusChange": [
            {
                "changeDate": "2023-03-08T18:19:07.000+0000",
                "status": "InProgress"
            },
            {
                "changeDate": "2023-03-02T03:17:56.000+0000",
                "status": "Held"
            },
            {
                "changeDate": "2023-03-02T03:13:15.000+0000",
                "status": "Pending"
            }
        ],
        "troubleTicketRelationship": [
            {
                "relationshipType": "Parent",
                "id": "500RO000002K2YXYA0"
            }
        ],
        "statusChangeDate": "2023-03-08T18:19:07.000Z",
        "name": "00001022",
        "id": "00001022",
        "severity": "Critical",
        "lastUpdate": "2023-03-11T04:05:50.000+0000",
        "resolutionDate": "2021-08-03T18:59:51.000+0000",
        "ticketType": "Manage Account",
        "status": "Pending",
        "priority": "Medium",
        "creationDate": "2022-09-21T05:24:40.000+0000",
        "description": "This is sample description for testing",
        "href": "/services/apexrest/vlocity_cmt/tmforum/troubleticket/v1/troubleticket/00001022"
    }
    ```
    
*   **400** There was an issue with your request.
    
    Media type: `application/json`. Schema: `Error`.
    
    _Example_
    
    ```
    code: "400"
    reason: Invalid picklist value for :Priority
    ```
    
*   **404** Resource not found.
    
    Media type: `application/json`. Schema: `Error`.
    
    _Example_
    
    ```
    code: NOT_FOUND
    reason: There are no matching resource.
    message: There are no data in system or not data for specified filters.
    ```
    
*   **500** Internal server Error
    
    Media type: `application/json`. Schema: `Error`.
    
    _Example_
    
    ```
    code: "500"
    reason: Internal server Error
    ```
    

## Schemas

### Error

Shown when an API throws an error, typically with an HTTP error response code (3xx, 4xx, or 5xx).

*   `code` (_string_, required) Specifies the application-relevant detail defined in the API or a common list.
*   `reason` (_string_, required) Describes the reason for the error, which can be shown to a client user.
*   `message` (_string_) Describes the detailed reason for the error.

### createTroubleTicket

*   `name` (_string_) A string. Name of the trouble ticket, typically a short description provided by the user that create the ticket.
*   `description` (_string_, required) Description of the trouble or issue
*   `priority` (_string_) The priority of the trouble ticket and how quickly the issue should be resolved. The supported values are org specific and are dependent on the configuration within the org.
*   `severity` (_string_, required) The severity of the issue. Indicate the implication of the issue on the expected functionality. The supported values are org specific and are dependent on the configuration within the org.
*   `ticketType` (_string_, required) represent a business type of the trouble ticket e.g. incident, complain, request. The supported values are org specific and are dependent on the configuration within the org.
*   `attachment` (_array of object_) File(s) attached to the trouble ticket. e.g. picture of broken device, scaning of a bill or charge
    
    Includes all fields of `AttachmentRefOrValue`.
    
*   `channel` (_object_) The channel that origin the trouble ticket. The supported values are org specific and are dependent on the configuration within the org
    
    Includes all fields of `ChannelRef`.
    
*   `note` (_array of object_) The note(s) that are associated to the ticket.
    
    Includes all fields of `Note`.
    
*   `relatedEntity` (_array of object_) An entity that is related to the ticket such as a bill, a product, etc. The entity against which the ticket is associated.
    
    Includes all fields of `RelatedEntity`.
    
*   `relatedParty` (_array of object_) The related party(ies) that are associated to the ticket.
    
    Includes all fields of `RelatedParty`.
    
*   `status` (_string_) The current status of the trouble ticket. The supported values are org specific and are dependent on the configuration within the org.
*   `troubleTicketRelationship` (_array of object_) A list of trouble ticket relationships (TroubleTicketRelationship \[\*\]). Represents a relationship between trouble tickets
    
    Includes all fields of `TroubleTicketRelationship`.
    

### AttachmentRefOrValue

Specifies an attachment by a value or by a reference. The attachment provides additional description of an element, such as a document, a video, or a picture.

*   `content` (_string_, required) Retrieves the actual contents of the attachment object, if embedded, encoded as base64.
*   `description` (_string_) Describes the content of the attachment.  
    Example: `Photograph of the Product`.
*   `mimeType` (_string_) Specifies the attachment mime type, such as an extension file for a video, a picture, and a document.
*   `name` (_string_, required) Specifies the name of the attachment.
*   `url` (_string_) The Uniform Resource Locator, which is a web page address and a subset of URI.  
    Example: `http://host/Content/4aafacbd-11ff-4dc8-b445-305f2215715f`.

### ChannelRef

Specifies the channel to which the resource references. For example, a channel for selling product offerings or for opening a ticket for an issue. The supported values are org specific and are dependent on the configuration within the org

*   `name` (_string_, required) Specifies the name of the channel.
*   `@type` (_string_) Defines the subclass extensible name when subclassing.

### Note

Provides additional information about a given entity.

*   `author` (_string_) Author of the note.
*   `date` (_datetime_) Author of the note.
*   `id` (_string_) Identifier of the note within its containing entity.
*   `text` (_string_, required) Specifies the text of the note.
*   `@type` (_string_) Defines the subclass entity name when subclassing.

### RelatedEntity

A reference to an entity, where the type of the entity is not known in advance.

*   `id` (_string_, required) Specifies a unique identifier of the related party.
*   `name` (_string_) Specifies the name of the related entity.
*   `@referredType` (_string_, required) The actual type of the target instance when needed for disambiguation.

### RelatedParty

Defines a party or party role that's linked to a specific entity.

*   `id` (_string_, required) Specifies a unique identifier of the related party.
*   `name` (_string_) Specifies the name of the related entity.
*   `@referredType` (_string_) The actual type of the target instance when needed for disambiguation.

### TroubleTicketRelationship

Represents a relationship between trouble Trouble Tickets

*   `id` (_string_, required) Unique identifier of the Trouble Ticket
*   `relationshipType` (_string_) Describes the relation to the entity. The supported relationship is Parent.